/*
** from2xxx -    rusconv.c.
**            .
**   - 2  1998 .
** (c)w_re --  .
*/

/*
**  write_it    ,   handle
** bytes    buf.    -  !0  - 0.
*/
#ifdef _FOR_WIN_
int
write_it (HANDLE handle, void *buf, DWORD bytes) {
   DWORD readed;
   int   ccode = 0;
   ccode = WriteFile (handle, buf, bytes, &readed, NULL);
   if (ccode) {
      ccode = (bytes == readed);
   };
   return ccode;
};
#endif

#ifndef _FOR_WIN_
int
write_it (HANDLE handle, void *buf, int bytes) {
   return bytes == write (handle, buf, bytes);
};
#endif

/*
**    ,   xxx2yyy:
** table     -   ,   'byte xxx2yyy[]'
** table_ext -    
** hOut      -     .
*/
byte           *table;
struct latChar *table_ext;
HANDLE         hOut;

/*
**  xxx2yyy    :
**  ,      .
**   , .      
**  ,   -    .
**  :
**  0 -  .
** !0 -  .
*/
int
xxx2yyy (void) {
   /*
   **     .
   */
   int      rest_in = (int)bytes_readed;
   /*
   **      .
   */
   byte     *pIn = pBuf_in, *pOut = pBuf_out;
   size_t   bytes_to_write;
   byte     b;
   int      ccode = 0;
   /*
   **  .
   */
   while (rest_in--) {
      b = *pIn++;
      /*
      **    .
      **  DOS/WIN -  '13 10',  UNIX -  '10'.
      ** ,        '13'.
      */
      if (flag_crlf2cr)
         if (b == 13)
            continue;
      if (flag_cr2crlf) {
         if (b == 10) {
            *pOut++ = 13;
            if (pOut >= pEnd_buf_out) {
               if (!write_it (hOut, pBuf_out, buf_size)) {
                  ccode = 1;
                  goto exit_proc;
               };
               pOut = pBuf_out;
            };
         }; /* if (b == 10) */
      };    /* if (flag_cr2crlf) */
      /*
      **  .
      **   ,    .
      */
      *pOut++ = *(table + b);
      if (pOut >= pEnd_buf_out) {
         if (!write_it (hOut, pBuf_out, buf_size)) {
            ccode = 1;
            goto exit_proc;
         };
         pOut=pBuf_out;
      }; /* if (pOut >= pEnd_buf_out) */
   };    /*   */
   /*
   **    -   
   ** ,  - ,   . 
   **  ,   .
   */
   bytes_to_write = (size_t)(pOut - pBuf_out);
   if (!write_it (hOut, pBuf_out, bytes_to_write)) {
      ccode = 1;
      goto exit_proc;
   };
   ccode = 0;
exit_proc:
   return ccode;
}; /* xxx2yyy() */

/*
**  ,    xxx   yyy.
**  unix-     
**        DOS- (
**    ).
** #define F1(aaa, bbb, descr) \
**   int \
**   do_##aaa##2##bbb (void) { \
**      table =  ##aaa##2##bbb; \
**      hOut  =  descr; \
**      return xxx2yyy (); \
**   };
** , , F1 (alt, koi, hKoi)  
** int
** do_alt2koi (void) {
**    table = alt2koi;
**    hOut  = descr;
**    return xxx2yyy ();
** };
*/

do_alt2alt (void) {table=alt2alt; hOut=hAlt; return xxx2yyy();}
do_koi2alt (void) {table=koi2alt; hOut=hAlt; return xxx2yyy();}
do_mac2alt (void) {table=mac2alt; hOut=hAlt; return xxx2yyy();}
do_win2alt (void) {table=win2alt; hOut=hAlt; return xxx2yyy();}
do_alt2koi (void) {table=alt2koi; hOut=hKoi; return xxx2yyy();}
do_koi2koi (void) {table=koi2koi; hOut=hKoi; return xxx2yyy();}
do_mac2koi (void) {table=mac2koi; hOut=hKoi; return xxx2yyy();}
do_win2koi (void) {table=win2koi; hOut=hKoi; return xxx2yyy();}
do_alt2mac (void) {table=alt2mac; hOut=hMac; return xxx2yyy();}
do_koi2mac (void) {table=koi2mac; hOut=hMac; return xxx2yyy();}
do_mac2mac (void) {table=mac2mac; hOut=hMac; return xxx2yyy();}
do_win2mac (void) {table=win2mac; hOut=hMac; return xxx2yyy();}
do_alt2win (void) {table=alt2win; hOut=hWin; return xxx2yyy();}
do_koi2win (void) {table=koi2win; hOut=hWin; return xxx2yyy();}
do_mac2win (void) {table=mac2win; hOut=hWin; return xxx2yyy();}
do_win2win (void) {table=win2win; hOut=hWin; return xxx2yyy();}

int
xxx2lat (void) {
   int      rest_in = bytes_readed;
   byte     *pIn = pBuf_in, *pOut = pBuf_out;
   size_t   bytes_to_write;
	byte     b, bLat, *str;
   struct latChar *cur;
   int      ccode = 0;
   int      i, j, len;
   while (rest_in--) {
      b= * pIn++;
      if (flag_crlf2cr)
         if (b == 13)
            continue;
      if (flag_cr2crlf) {
         if (b == 10) {
            *pOut++ = 13;
            if (pOut >= pEnd_buf_out) {
               if (!write_it (hOut, pBuf_out, buf_size)) {
                  ccode = 1;
                  goto exit_proc;
					};
               pOut = pBuf_out;
            };
         }; /* if (b == 10) */
      };    /* if (flag_cr2crlf) */
      /*
		** -     .
      **      '- '.
      **     ,    - '\0'.  
      **    table_ext.
      */
      bLat = *(table + b);
      /*
      **  '- '.
      */
      if (bLat) {
         *pOut++ = bLat;
      /*
      **     '\0',     ,
      **    .  ,
		**      "\0'.
		*/
		} else if (!b) {
			*pOut++ = 0;
			if (pOut >= pEnd_buf_out) {
				if (!write_it (hOut,pBuf_out,buf_size)) {
					ccode = 1;
					goto exit_proc;
				};
				pOut = pBuf_out;
			}
		} else {
			/*
			**   .
         **   table_ext    .
         **    ,  - .
         */
         ccode = 1;
			cur   = table_ext;
         for (i = 0; i < table_ext_size; i++) {
            /*
            **     ,   .
            */
            if (cur->ch != b) {
               cur++;
               continue;
            };
            /*
            **    .   .
            */
            len = cur->len;
            if (len > 4)
               break;
            /*
            **  
            */
				str = cur->to;
				for (j = 0; j < len; j++ ) {
					*pOut++ = *str++;
					if (pOut >= pEnd_buf_out) {
						if (!write_it (hOut, pBuf_out, buf_size)) {
							ccode = 1;
							goto exit_proc;
						};
						pOut = pBuf_out;
					}; /* if (pOut >= pEnd_buf_out) */
				}; /* for (j = 0; j < len; j++ ) */
				/*
				**   -   .
				*/
				ccode = 0;
				break;
			}; /* for (i = 0; i < table_ext_size; i++) */
			/*
			**    ,   - 
			*/
			if (ccode) {
				print_internal_error (__FILE__, __LINE__);
				goto exit_proc;
			};
      };    /* if (bLat) / else if (b) */
      if (pOut >= pEnd_buf_out) {
			if (!write_it (hOut,pBuf_out,buf_size)) {
            ccode = 1;
            goto exit_proc;
         };
         pOut = pBuf_out;
      }; /* if (pOut >= pEnd_buf_out) */
   };    /* while (rest_in--) */
   bytes_to_write = (size_t)(pOut - pBuf_out);
   if (!write_it (hOut, pBuf_out, bytes_to_write)) {
      ccode = 1;
      goto exit_proc;
   };
	ccode = 0;
exit_proc:
	return ccode;
}; /* xxx2lat() */

int
do_alt2lat (void) {
	table       =  alt2lat;
	table_ext   =  alt2lat_ext;
	hOut        =  hLat;
	return xxx2lat ();
};

int
do_koi2lat (void) {
	table       =  koi2lat;
	table_ext   =  koi2lat_ext;
	hOut        =  hLat;
	return xxx2lat ();
};

int
do_mac2lat (void) {
	table       =  mac2lat;
	table_ext   =  mac2lat_ext;
	hOut        =  hLat;
	return xxx2lat ();
};

int
do_win2lat (void) {
	table       =  win2lat;
	table_ext   =  win2lat_ext;
	hOut        =  hLat;
	return xxx2lat ();
};

